#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire300four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 300"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire300four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four3004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2four3004xi = {
                1:'101x-107y261z',
                2:'103x-36y279z',
                3:'105x-275y52z',
                4:'107x-32y278z',
                5:'108x-103y259z',
                6:'109x-160y228z',
                7:'110x-206y187z',
                8:'112x-26y276z',
                9:'116x-21y275z',
                10:'116x-99y258z',
                11:'119x-156y226z',
                12:'119x-15y274z',
                13:'120x-270y49z',
                14:'122x-201y185z',
                15:'123x-94y256z',
                16:'123x-9y273z',
                17:'126x-3y272z',
                18:'128x-151y224z',
                19:'130x-89y254z',
                20:'133x-196y182z',
                21:'134x-264y46z',
                22:'136x-84y253z',
                23:'137x-146y222z',
                24:'143x-78y251z',
                25:'144x-190y180z',
                26:'147x-140y220z',
                27:'148x-256y43z',
                28:'149x-71y250z',
                29:'155x-134y218z',
                30:'155x-184y178z',
                31:'155x-64y248z',
                32:'15x-291y70z',
                33:'160x-57y246z',
                34:'161x-249y41z',
                35:'164x-127y216z',
                36:'165x-49y245z',
                37:'166x-177y175z',
                38:'170x-41y243z',
                39:'172x-119y214z',
                40:'174x-240y38z',
                41:'174x-32y241z',
                42:'176x-169y173z',
                43:'178x-23y239z',
                44:'17x-13y299z',
                45:'180x-111y212z',
                46:'182x-14y237z',
                47:'185x-5y236z',
                48:'186x-160y170z',
                49:'187x-102y210z',
                50:'187x-231y35z',
                51:'194x-93y207z',
                52:'196x-152y168z',
                53:'199x-221y32z',
                54:'201x-84y205z',
                55:'205x-142y165z',
                56:'207x-74y203z',
                57:'20x-14y298z',
                58:'20x-57y293z',
                59:'211x-211y29z',
                60:'212x-63y201z',
                61:'213x-132y163z',
                62:'217x-53y199z',
                63:'222x-121y160z',
                64:'222x-199y26z',
                65:'222x-42y196z',
                66:'226x-30y194z',
                67:'229x-110y158z',
                68:'229x-18y192z',
                69:'232x-188y23z',
                70:'232x-6y190z',
                71:'242x-175y20z',
                72:'24x-14y298z',
                73:'24x-59y293z',
                74:'251x-163y17z',
                75:'259x-149y14z',
                76:'267x-136y11z',
                77:'273x-121y8z',
                78:'27x-14y298z',
                79:'280x-107y5z',
                80:'285x-92y2z',
                81:'289x-77y0z',
                82:'28x-60y292z',
                83:'30x-290y67z',
                84:'315x-132y207z',
                85:'31x-14y298z',
                86:'33x-61y291z',
                87:'34x-14y297z',
                88:'37x-62y291z',
                89:'38x-13y297z',
                90:'41x-12y296z',
                91:'42x-62y290z',
                92:'45x-10y296z',
                93:'45x-289y64z',
                94:'47x-62y289z',
                95:'48x-8y295z',
                96:'49x-119y270z',
                97:'51x-6y295z',
                98:'52x-61y288z',
                99:'54x-4y294z',
                100:'56x-119y269z',
                101:'58x-1y294z',
                102:'58x-61y287z',
                103:'61x-287y61z',
                104:'63x-118y268z',
                105:'63x-60y287z',
                106:'68x-58y286z',
                107:'71x-117y266z',
                108:'73x-56y285z',
                109:'76x-284y58z',
                110:'78x-115y265z',
                111:'78x-54y284z',
                112:'80x-169y234z',
                113:'84x-51y283z',
                114:'86x-113y264z',
                115:'89x-167y232z',
                116:'89x-48y282z',
                117:'91x-280y55z',
                118:'93x-110y262z',
                119:'94x-44y281z',
                120:'98x-41y280z',
                121:'99x-164y230z'}
#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire300four4xi" usage = "target function for charge3004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire300four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE300FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE300FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE300FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE300FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE300FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four3004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE300FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE300FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE300FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four3004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four3004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE300FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE300FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE300FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire300four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                    